#
# spec file for package rng-tools
#
# Copyright (c) 2016 SUSE LINUX GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#


Name:           rng-tools
Version:        5
Release:        10.5
Summary:        Support daemon for hardware random device
License:        GPL-3.0+
Group:          System/Kernel
Url:            http://sourceforge.net/projects/gkernel/
Source:         http://sourceforge.net/projects/gkernel/files/%{name}/%{version}/%{name}-%{version}.tar.gz
Source2:        %{name}.service
Source3:        90-hwrng.rules
Patch0:         rng-tools-check_signals.patch
BuildRequires:  libgcrypt-devel
BuildRequires:  pkgconfig
BuildRequires:  pkgconfig(systemd)
BuildRequires:  pkgconfig(udev)
Supplements:    modalias(pci:v00001022d00007443sv*sd*bc*sc*i*)
Supplements:    modalias(pci:v00001022d0000746Bsv*sd*bc*sc*i*)
Supplements:    modalias(pci:v00008086d00002410sv*sd*bc*sc*i*)
Supplements:    modalias(pci:v00008086d00002420sv*sd*bc*sc*i*)
Supplements:    modalias(pci:v00008086d00002440sv*sd*bc*sc*i*)
Supplements:    modalias(pci:v00008086d0000244Csv*sd*bc*sc*i*)
Supplements:    modalias(pci:v00008086d00002450sv*sd*bc*sc*i*)
Supplements:    modalias(pci:v00008086d00002480sv*sd*bc*sc*i*)
Supplements:    modalias(pci:v00008086d0000248Csv*sd*bc*sc*i*)
Supplements:    modalias(pci:v00008086d000024C0sv*sd*bc*sc*i*)
Supplements:    modalias(pci:v00008086d000024CCsv*sd*bc*sc*i*)
Supplements:    modalias(pci:v00008086d000024D0sv*sd*bc*sc*i*)
Supplements:    modalias(pci:v00008086d000025A1sv*sd*bc*sc*i*)
Supplements:    modalias(pci:v00008086d00002640sv*sd*bc*sc*i*)
Supplements:    modalias(pci:v00008086d00002641sv*sd*bc*sc*i*)
Supplements:    modalias(pci:v00008086d00002670sv*sd*bc*sc*i*)
Supplements:    modalias(pci:v00008086d00002671sv*sd*bc*sc*i*)
Supplements:    modalias(pci:v00008086d00002672sv*sd*bc*sc*i*)
Supplements:    modalias(pci:v00008086d00002673sv*sd*bc*sc*i*)
Supplements:    modalias(pci:v00008086d00002674sv*sd*bc*sc*i*)
Supplements:    modalias(pci:v00008086d00002675sv*sd*bc*sc*i*)
Supplements:    modalias(pci:v00008086d00002676sv*sd*bc*sc*i*)
Supplements:    modalias(pci:v00008086d00002677sv*sd*bc*sc*i*)
Supplements:    modalias(pci:v00008086d00002678sv*sd*bc*sc*i*)
Supplements:    modalias(pci:v00008086d00002679sv*sd*bc*sc*i*)
Supplements:    modalias(pci:v00008086d0000267Asv*sd*bc*sc*i*)
Supplements:    modalias(pci:v00008086d0000267Bsv*sd*bc*sc*i*)
Supplements:    modalias(pci:v00008086d0000267Csv*sd*bc*sc*i*)
Supplements:    modalias(pci:v00008086d0000267Dsv*sd*bc*sc*i*)
Supplements:    modalias(pci:v00008086d0000267Esv*sd*bc*sc*i*)
Supplements:    modalias(pci:v00008086d0000267Fsv*sd*bc*sc*i*)
Supplements:    modalias(pci:v00008086d000027B8sv*sd*bc*sc*i*)
Supplements:    modalias(pci:v00008086d000027B9sv*sd*bc*sc*i*)
Supplements:    modalias(pci:v00008086d000027BDsv*sd*bc*sc*i*)
Supplements:    modalias(virtio:d00000004v*)
ExclusiveArch:  aarch64 %ix86 ia64 x86_64 %{arm} ppc64 ppc64le
%{?systemd_requires}
%{!?_udevrulesdir: %global _udevrulesdir %(pkg-config --variable=udevdir udev)/rules.d }

%description
This  daemon  feeds data from a random number generator to the kernel's
random  number  entropy  pool,  after	first checking the data to
ensure that it is properly random.

%prep
%setup -q
%patch0

%build
%configure
make %{?_smp_mflags}

%install
make DESTDIR=%{buildroot} install %{?_smp_mflags}
install -D -m 0644 %{SOURCE2} %{buildroot}%{_unitdir}/%{name}.service
install -D -m 0644 %{SOURCE3} %{buildroot}%{_udevrulesdir}/90-hwrng.rules
ln -sf /sbin/service %{buildroot}%{_sbindir}/rc%{name}

%pre
%service_add_pre %{name}.service

%post
%{?udev_rules_update:%{udev_rules_update}}
%service_add_post %{name}.service

%preun
%service_del_preun %{name}.service

%postun
%service_del_postun %{name}.service

%files
%defattr(-,root,root)
%doc NEWS
%{_bindir}/rngtest
%{_sbindir}/rngd
%{_mandir}/man?/*.*.gz
%{_unitdir}/%{name}.service
%{_sbindir}/rc%{name}
%{_udevrulesdir}/90-hwrng.rules

%changelog
* Sat Feb  6 2016 crrodriguez@opensuse.org
- 90-hwrng.rules: Improve udev rule, autostart rngd only
  when there are hwrng drivers available and one is actually
  bound to the device.
* Mon Oct 19 2015 dmueller@suse.com
- enable aarch64 as well
* Sat Oct 17 2015 dvaleev@suse.com
- Enable Power64 architecture. Starting with Power7+ we have in
  CPU random number generator
* Thu Sep 18 2014 ro@suse.de
- add patch: rng-tools-check_signals.patch (bnc#897335)
  check for signals in all loops to react to SIGINT/SIGTERM
* Wed Sep  3 2014 idonmez@suse.com
- Apparently --fill-watermark expects a number between 0 and 4096
  now. So we now set it to 3700 which is ~90%% of 4096.
* Mon Aug 25 2014 idonmez@suse.com
- Update to version 5
  * Support RDRAND capable systems that don't have AES-NI
  * Man page spelling fixes
  * Don't use fixed AES key for data reduction
  * Platform: Support x32. x86-64 micro-optimizations.
  * Fix RDRAND data reduction
  * Enable RDSEED instruction
- Add libgcrypt dependency needed for RDRAND
- Add back --fill-watermark=90%% to the service file
- Package NEWS file
- Spec cleanup
* Fri Aug 22 2014 crrodriguez@opensuse.org
- package is needed on %%arm (raspberry pi at least).
* Tue Jun 24 2014 crrodriguez@opensuse.org
- systemd: Do not start in containers, in that case
  entropy comes from the "host"
- systemd: Conflict with haveged, only one entropy daemon
  must be running.
* Wed Apr 30 2014 crrodriguez@opensuse.org
- Fix automagic startup with udev/systemd virtio-rng KERNEL
  name is hw_random not hwrng..
* Wed Apr 30 2014 crrodriguez@opensuse.org
- in some parallel universe --fill-watermark took a percentage
  value, not in this incarnation at least, where it takes
  an integer. just use the sane builtin default
* Fri Dec 27 2013 crrodriguez@opensuse.org
- udev does not like rules without a new line
* Sun Nov 24 2013 crrodriguez@opensuse.org
- there is no trousers-devel requirement anymore
- define _udevrulesdir only if not already defined
- run %%udev_rules_update, if defined.
* Wed Oct 23 2013 p.drouand@gmail.com
- Drop old sysvinit stuff; none of distribution targets use it anymore
- Remove redundant %%clean section
- Remove useless automake BuildRequires, CFLAGS export and autoreconf call
* Mon Sep  2 2013 crrodriguez@opensuse.org
- in a previous change I removed WantedBy=multi-user.target
  from the systemd service file because the service can get
  automatically started by udev, however there are usecases
  on which manual start is desirable, restore that.
* Wed May 15 2013 ro@suse.de
- remove option "--feed-interval=1" from init-script and
  service file, no current version of rng-tools has ever
  known this option (bnc#819764)
* Thu Apr 11 2013 crrodriguez@opensuse.org
- Just to be in the safe side, put udev rules later into
  the mix 50-hwrng.rules --> 90-hwrng.rules
* Tue Apr  9 2013 crrodriguez@opensuse.org
- 50-hwrng.rules + rng-tools.service, use activation by systemd+udev
  combo, the service will come up automatically when the kernel
  registers a /dev/hwrng device, service no longer requires
  manual intervention to work at all.
* Thu Oct  4 2012 lars@linux-schulserver.de
- update to version 4:
  * Add RDRAND instruction support
  * Add -q and -v options for quiet and verbose output
  * Add -p option for specifying PID file (text file containing daemon's PID)
  * Disable entropy source if facing continued failures, but be
    tolerant of the occasional fault.
  * Default device is now the preferred /dev/hwrng
  * Do not use TPM device for RNG access, if /dev/hwrng is present
    (TPM RNG is exported via the kernel, in newer kernels)
- require $remote_fs in init script as binaries are below /usr
* Sun Jan 29 2012 tabraham@novell.com
- Update to version 3
  * add rngteswt program
  * support TPM chip's hardware RNG (and thus, a framework for
    supporting multiple entropy sources)
  * change default hardware RNG device name to "/dev/hw_random"
* Sat Dec 31 2011 crrodriguez@opensuse.org
- Put rngd back into %%{_sbindir} /usr is mounted in the initrd now.
* Fri Dec 16 2011 crrodriguez@opensuse.org
- Support systemd.
* Thu Dec  1 2011 coolo@suse.com
- add automake as buildrequire to avoid implicit dependency
* Wed Aug 10 2011 crrodriguez@opensuse.org
- Work around VIA Nano xstore bug
- Add support for Linux 3.0
- Enable large file support
- Enable VIA PadLock support on x86_64
* Wed Mar  9 2011 coolo@novell.com
- prereq sysvinit services
* Mon Nov 22 2010 ro@suse.de
- change license from GPLv2+ to GPLv3+ as the tpm_engine code
  in the ubuntu patch uses that license (bnc#653119)
* Wed Nov 10 2010 ro@suse.de
- do not report init script as failed if no hardware found
  (bnc#624198)
* Wed May 19 2010 ro@suse.de
- move rngd back to /sbin and drop remotefs dependency from
  init script
* Mon May 17 2010 ro@suse.de
- do not enable by default
* Thu May 13 2010 cristian.rodriguez@opensuse.org
- use debian/ubuntu rng-tools_mt which is under active development
* Sun Apr 25 2010 crrodriguez@opensuse.org
- add Suplemments for all currently supported hwrngs
* Fri Jan  9 2009 olh@suse.de
- use ExclusiveArch as in /SRC/arch/
* Fri Nov  9 2007 bwalle@suse.de
- added PreReq for %%fillup_prereq
* Sun Apr  1 2007 bwalle@suse.de
- added init script that also probes hardware if the module
  cannot be probed by PCI IDs
* Wed Jan 25 2006 mls@suse.de
- converted neededforbuild to BuildRequires
* Tue Aug 24 2004 ro@suse.de
- update to version 2
* Wed Jul 28 2004 ro@suse.de
- update to version 1.1
* Thu Aug 21 2003 ro@suse.de
- created package version 1.0
